/*!
*
*       JSMatrix : JavaScript matrix and vector implementation
*                      version 0.6 (2012-04-20)
*
*             Copyright (C)  2011 - 2012  Jan Stransky
*
*      Czech Technical University, Faculty of Civil Engineering,
*  Department of Structural Mechanics, 166 29 Prague, Czech Republic
*
*
*  JSMatrix is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  JSMatrix is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
var JSM_X=0;var JSM_Y=1;var JSM_Z=2;var JSM_TOL=1e-8;var JSM_TOL2=1e-32;var JSM_ROUNDFACTOR=10000;Vector=function(a){this.nElements=a||0;for(var b=0;b<this.nElements;b++){this[b]=0}};Vector.prototype.empty=function(){this.resize(0)};Vector.prototype.isEmpty=function(){return this.nElements==0};Vector.prototype.zero=function(){for(var a=0;a<this.nElements;a++){this[a]=0}};Vector.prototype.beFullOfOnes=function(){for(var a=0;a<this.nElements;a++){this[a]=1}};Vector.prototype.one=Vector.prototype.beFullOfOnes;Vector.prototype.size=function(){return this.nElements};Vector.prototype.sum=function(){var a=0;for(var b=0;b<this.nElements;b++){a+=this[b]}return a};Vector.prototype.max=function(){ret=-1e+64;for(var a=0;a<this.nElements;a++){if(this[a]>ret){ret=this[a]}}return ret};Vector.prototype.min=function(){ret=1e+64;for(var a=0;a<this.nElements;a++){if(this[a]<ret){ret=this[a]}}return ret};Vector.prototype.indexOf=function(b){for(var a=0;a<this.nElements;a++){if(Math.abs(this[a]-b)<JSM_TOL){return a}}return null};Vector.prototype.isEqualTo=function(a){if(!this.isSameSizeAs(a)){return false}for(var b=0;b<this.nElements;b++){if(Math.abs(this[b]-a[b])>JSM_TOL){return false}}return true};Vector.prototype.get=function(a){if(a<0||a>=this.nElements){return null}return this[a]};Vector.prototype.set=function(a,b){if(a<0||a>=this.nElements){return}this[a]=b};Vector.prototype.incr=function(a,b){if(a<0||a>=this.nElements){return}if(b){this[a]+=b}};Vector.prototype.isSameSizeAs=function(a){return this.nElements==a.nElements};Vector.prototype.canMultiplyMat=function(a){return this.nElements==a.nCols};canMultiplyMatFromLeft=Vector.prototype.canMultiplyMat;Vector.prototype.fromArray=function(b){var c=b.length;var a;for(a=0;a<c;a++){this[a]=b[a]}for(a=c;a<this.nElements;a++){delete this[a]}this.nElements=c};Vector.prototype.toArray=function(){var a=[];for(var b=0;b<this.nElements;b++){a[b]=this[b]}return a};Vector.prototype.add=function(b){if(!this.isSameSizeAs(b)){return null}var a=new Vector();for(var c=0;c<this.nElements;c++){a[c]=this[c]+b[c]}a.nElements=this.nElements;return a};Vector.prototype.iadd=function(a){if(!this.isSameSizeAs(a)){return}for(var b=0;b<this.nElements;b++){this[b]+=a[b]}};Vector.prototype.beSumOf=function(b,a){if(!b.isSameSizeAs(a)){return}var c,d=b.nElements;for(c=0;c<d;c++){this[c]=b[c]+a[c]}for(c=d;c<this.nElements;c++){delete this[c]}this.nElements=d};Vector.prototype.sub=function(b){if(!this.isSameSizeAs(b)){return null}var a=new Vector();for(var c=0;c<this.nElements;c++){a[c]=this[c]-b[c]}a.nElements=this.nElements;return a};Vector.prototype.isub=function(a){if(!this.isSameSizeAs(a)){return}for(var b=0;b<this.nElements;b++){this[b]-=a[b]}};Vector.prototype.beDifferenceOf=function(b,a){if(!b.isSameSizeAs(a)){return}var c,d=b.nElements;for(c=0;c<d;c++){this[c]=b[c]-a[c]}for(c=d;c<this.nElements;c++){delete this[c]}this.nElements=d};Vector.prototype.dot=function(b,d){var d=d||-1;if(d<=0||d>this.nElements){d=this.nElements}if(d>b.nElements){return null}var a=0;for(var c=0;c<d;c++){a+=this[c]*b[c]}return a};Vector.prototype.squaredNorm=function(){return this.dot(this)};Vector.prototype.norm=function(){return Math.sqrt(this.dot(this))};Vector.prototype.normalize=function(){var a=this.norm();if(a==0){return}this.imulf(1/a)};Vector.prototype.normalized=function(){var d=this.norm();if(d==0){return null}var b,a=new Vector(),c=1/d;for(b=0;b<this.nElements;b++){a[b]=this[b]*c}a.nElements=this.nElements;return a};Vector.prototype.squaredEnergyNorm=function(a){var a=a;return this.mulm(a).dot(this)};Vector.prototype.energyNorm=function(a){var a=a;return Math.sqrt(this.squaredEnergyNorm(a))};Vector.prototype.dyadic=function(b){var b=b;var a=new Matrix();for(var d=0;d<this.nElements;d++){a[d]={};for(var e=0;e<b.nElements;e++){a[d][e]=this[d]*b[e]}}a.nRows=this.nElements;a.nCols=b.nElements;return a};Vector.prototype.otimes=Vector.prototype.dyadic;Vector.prototype.outer=Vector.prototype.dyadic;Vector.prototype.tensor=Vector.prototype.dyadic;Vector.prototype.cross=function(a){if(this.nElements!=3||a.nElements!=3){return null}return Vector.create([this[1]*a[2]-this[2]*a[1],this[2]*a[0]-this[0]*a[2],this[0]*a[1]-this[1]*a[0]])};Vector.prototype.beCrossProductOf=function(b,a){if(b.nElements!=3||a.nElements!=3){return}this[0]=b[1]*a[2]-b[2]*a[1];this[1]=b[2]*a[0]-b[0]*a[2];this[2]=b[0]*a[1]-b[1]*a[0];for(var c=3;c<this.nElements;c++){delete this[c]}this.nElements=3};Vector.prototype.negated=function(){return this.mulf(-1)};Vector.prototype.neg=Vector.prototype.negated;Vector.prototype.negate=function(){for(var a=0;a<this.nElements;a++){this[a]*=-1}};Vector.prototype.ineg=Vector.prototype.negate;Vector.prototype.beNegativeOf=function(a){var b,c=a.nElements;for(b=0;b<c;b++){this[b]=-a[b]}for(b=c;b<this.nElements;b++){delete this[b]}this.nElements=c};Vector.prototype.mulf=function(b){var a=new Vector();for(var c=0;c<this.nElements;c++){a[c]=b*this[c]}a.nElements=this.nElements;return a};Vector.prototype.imulf=function(a){for(var b=0;b<this.nElements;b++){this[b]*=a}};Vector.prototype.mulm=function(d){if(!this.canMultiplyMat(d)){return null}var b=new Vector(),a,h=d.nCols,f=this.nElements;for(var g=0;g<h;g++){a=0;for(var e=0;e<f;e++){a+=this[e]*d[e][g]}b[g]=a}b.nElements=h;return b};Vector.prototype.mul=function(a){if(a instanceof Matrix){return this.mulm(a)}if((typeof a).toLowerCase()=="number"){return this.mulf(a)}return null};Vector.prototype.x=Vector.prototype.mul;Vector.prototype.beProductOf=function(d,b){if(!d.canMultiplyVec(b)){return}var f=d.nRows;var h=d.nCols;var a,e,g;for(e=0;e<f;e++){a=0;for(g=0;g<h;g++){a+=d[e][g]*b[g]}this[e]=a}for(e=f;e<this.nElements;e++){delete this[e]}this.nElements=f};Vector.prototype.beTProductOf=function(d,b){if(!d.canMultiplyMat(b)){return}var f=b.nRows;var h=b.nCols;var a,e,g;for(g=0;g<h;g++){a=0;for(e=0;e<f;e++){a+=d[e]*b[e][g]}this[g]=a}for(g=h;g<this.nElements;g++){delete this[g]}this.nElements=h};Vector.prototype.getSubVector=function(a){var f=a.nElements==undefined?a.length:a.nElements;if(f>this.nElements){return null}var d,c;var b=new Vector();for(d=0;d<f;d++){c=a[d];if(c<0||c>=this.nElements){return null}b[d]=this[a[d]]}b.nElements=f;return b};Vector.prototype.getsv=Vector.prototype.getSubVector;Vector.prototype.beSubVectorOf=function(b,a){var d=a.nElements==undefined?a.length:a.nElements;if(d>b.nElements){return}var c;for(c=0;c<d;c++){if(a[c]<0||a[c]>=b.nElements){return}}for(c=0;c<d;c++){this[c]=b[a[c]]}for(c=d;c<this.nElements;c++){delete this[c]}this.nElements=d};Vector.prototype.setSubVector=function(a,b){var f=a.nElements==undefined?a.length:a.nElements;var d=b.nElements;if(d!=f){return}if(f>this.nElements){return}var c;for(c=0;c<f;c++){if(a[c]<0||a[c]>=this.nElements){return}}for(c=0;c<f;c++){this[a[c]]=b[c]}};Vector.prototype.setsv=Vector.prototype.setSubVector;Vector.prototype.incrSubVector=function(a,b){var f=a.nElements==undefined?a.length:a.nElements;var d=b.nElements;if(d!=f){return}if(f>this.nElements){return}var c;for(c=0;c<f;c++){if(a[c]<0||a[c]>=this.nElements){return}}for(c=0;c<f;c++){this[a[c]]+=b[c]}};Vector.prototype.incrsv=Vector.prototype.incrSubVector;Vector.prototype.decrSubVector=function(a,b){var f=a.nElements==undefined?a.length:a.nElements;var d=b.nElements;if(d!=f){return}if(f>this.nElements){return}var c;for(c=0;c<f;c++){if(a[c]<0||a[c]>=this.nElements){return}}for(c=0;c<f;c++){this[a[c]]-=b[c]}};Vector.prototype.decrsv=Vector.prototype.decrSubVector;Vector.prototype.assemble=function(b,a){var f=a.nElements==undefined?a.length:a.nElements;var d=this.nElements;if(d!=f){return}if(f>b.nElements){return}var c;for(c=0;c<f;c++){if(a[c]<0||a[c]>=b.nElements){return}}for(c=0;c<f;c++){b[a[c]]+=this[c]}};Vector.prototype.beRowOf=function(a,b){var e,d=a.nCols;for(e=0;e<d;e++){this[e]=a[b][e]}for(e=d;n<this.nElements;e++){delete this[e]}this.nElements=d};Vector.prototype.beColOf=function(a,e){var d,b=a.nRows;for(d=0;d<b;d++){this[d]=a[d][e]}for(d=b;n<this.nElements;d++){delete this[d]}this.nElements=b};Vector.prototype.beColumnOf=Vector.prototype.beColOf;Vector.prototype.copied=function(){var a=new Vector(),b,c=this.nElements;for(b=0;b<c;b++){a[b]=this[b]}a.nElements=c;return a};Vector.prototype.copy=Vector.prototype.copied;Vector.prototype.beCopyOf=function(a){var b=a.nElements,c;for(c=0;c<b;c++){this[c]=a[c]}for(c=b;c<this.nElements;c++){delete this[c]}this.nElements=b};Vector.prototype.toString=function(){var d=this.nElements,b,c;if(d==0){return"Vector([])\n"}var a="Vector([ ";for(b=0;b<d-1;b++){c=this[b];a+=c.toExponential(3)+", "}c=this[d-1];a+=c.toExponential(3)+" ])\n";return a};Vector.prototype.swapElements=function(c,b){if(c==b){return}if(c<0||b<0||c>=this.nElements||b>=this.nElements){return}var a=this[c];this[c]=this[b];this[b]=a};Vector.prototype.appendElements=function(a){if(a instanceof Vector){var c=a.nElements,b;for(b=0;b<c;b++){this[this.nElements]=a[b];this.nElements++}return}if(a instanceof Array){var c=a.length,b;for(b=0;b<c;b++){this.appendElements(a[b])}return}if((typeof a).toLowerCase()=="number"){this[this.nElements]=a;this.nElements++;return}};Vector.prototype.permuteElements=function(b,d){var f;if(b.nElements==undefined){f=b.length;var b=b.slice()}else{f=b.nElements;var b=b.toArray()}if(f!=this.nElements){return}for(var c=0;c<f;c++){if(c<0||c>=this.nElements){return}}var d=d||false;var a;if(d){for(var c=0;c<f;c++){a=b[c];while(a!=c){this.swapElements(c,a);b[c]=b[a];b[a]=a;a=b[c]}}}else{for(var c=f-1;c>0;c--){a=b[c];this.swapElements(c,a);b[b.indexOf(c)]=a}}return};Vector.prototype.elementsPermutation=function(a,d){var f=a.nElements==undefined?a.length:a.nElements;if(f!=this.nElements){return}for(var c=0;c<f;c++){if(c<0||c>=this.nElements){return}}var b=new Vector();if(d){for(c=0;c<this.nElements;c++){b[a[c]]=this[c]}}else{for(c=0;c<this.nElements;c++){b[c]=this[a[c]]}}b.nElements=this.nElements;return b};Vector.prototype.resize=function(a){if(a==this.nElements){return}if(a>this.nElements){for(var b=this.nElements;b<a;b++){this[b]=0}this.nElements=a;return}if(a<this.nElements){for(var b=a;b<this.nElements;b++){delete this[b]}this.nElements=a;return}};Vector.prototype.resized=function(a){var c,b=new Vector();if(a<=this.nElements){for(c=0;c<a;c++){b[c]=this[c]}}else{for(c=0;c<this.nElements;c++){b[c]=this[c]}for(c=this.nElements;c<a;c++){b[c]=0}}b.nElements=a;return b};Vector.prototype.toDiagonalMatrix=function(){var a=Matrix.Zeros(this.nElements,this.nElements);for(var b=0;b<this.nElements;b++){a[b][b]=this[b]}return a};Vector.prototype.beDiagonalFrom=function(a){if(!a.isSquare()){return}var c,b=a.nRows;for(c=0;c<b;c++){this[c]=a[c][c]}for(c=b;b<this.nElements;c++){delete this[c]}this.nElements=b};Vector.prototype.diag=function(a){if(a==undefined){return this.toDiagonalMatrix()}this.beDiagonalFrom(a)};Vector.prototype.beSolutionOf=function(b,e,d,a,c){var a=a==undefined?true:a;var b=a?b.copy():b;var e=e;this.beCopyOf(e);b.linSolve(this,d,false,c)};Vector.create=function(e){var b=e||[];var f=b.length;var c=new Vector();for(var d=0;d<f;d++){c[d]=b[d]}c.nElements=f;return c};Vector.UnitX=function(){return Vector.create([1,0,0])};Vector.UnitY=function(){return Vector.create([0,1,0])};Vector.UnitZ=function(){return Vector.create([0,0,1])};Vector.Zeros=function(a){var a=a||0;return new Vector(a)};Vector.Ones=function(a){var a=a||0;var c,b=new Vector();for(c=0;c<a;c++){b[c]=1}b.nElements=a;return b};Matrix=function(a,b){this.nRows=a||0;this.nCols=b||0;var d,e;for(d=0;d<this.nRows;d++){this[d]={};for(e=0;e<this.nCols;e++){this[d][e]=0}}};Matrix.prototype.empty=function(){this.resize(0,0)};Matrix.prototype.isEmpty=function(){return this.nRows==0&&this.nCols==0};Matrix.prototype.zero=function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<this.nCols;b++){this[a][b]=0}}};Matrix.prototype.beFullOfOnes=function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<this.nCols;b++){this[a][b]=1}}};Matrix.prototype.one=Matrix.prototype.beFullOfOnes;Matrix.prototype.beUnitMatrix=function(a){var a=a||0;if(a<=0){if(!this.isSquare){return}this.zero();for(var b=0;b<this.nRows;b++){this[b][b]=1}return}var d,e;this.resize(a,a);for(d=0;d<a;d++){this[d][d]=1}};Matrix.prototype.size=function(){return[this.nRows,this.nCols]};Matrix.prototype.trace=function(){if(!this.isSquare()){return null}var a=0;for(var b=0;b<this.nRows;b++){a+=this[b][b]}return a};Matrix.prototype.diagSum=Matrix.prototype.trace;Matrix.prototype.diagProduct=function(){if(!this.isSquare()){return null}var a=1;for(var b=0;b<this.nRows;b++){a*=this[b][b];if(a==0){return 0}}return a};Matrix.prototype.dprod=Matrix.prototype.diagProduct;Matrix.prototype.get=function(a,b){if(a<0||b<0){return null}if(a>=this.nRows||b>=this.nCols){return null}return this[a][b]};Matrix.prototype.set=function(a,d,b){if(a<0||d<0){return}if(a>=this.nRows||d>=this.nCols){return}this[a][d]=b};Matrix.prototype.incr=function(a,d,b){if(a<0||d<0){return}if(a>=this.nRows||d>=this.nCols){return}if(b){this[a][d]+=b}};Matrix.prototype.fromArray=function(d){var b,f,a=d.length,e=d[0].length;for(b=0;b<a;b++){if(b>=this.nRows){this[b]={}}for(f=0;f<e;f++){this[b][f]=d[b][f]}for(f=e;f<this.nCols;f++){delete this[b][f]}}for(b=a;b<this.nRows;b++){delete this[b]}this.nRows=a;this.nCols=e};Matrix.prototype.toArray=function(){var b,d,a=[];for(b=0;b<this.nRows;b++){a[b]=[];for(d=0;d<this.nCols;d++){a[b][d]=this[b][d]}}return a};Matrix.prototype.add=function(b){if(!this.isSameSizeAs(b)){return null}var e,g,d=this.nRows,f=this.nCols,a=new Matrix();for(e=0;e<d;e++){a[e]={};for(g=0;g<f;g++){a[e][g]=this[e][g]+b[e][g]}}a.nRows=d;a.nCols=f;return a};Matrix.prototype.iadd=function(a){if(!this.isSameSizeAs(a)){return}for(var b=0;b<this.nRows;b++){for(var d=0;d<this.nCols;d++){this[b][d]+=a[b][d]}}};Matrix.prototype.beSumOf=function(e,a){if(!e.isSameSizeAs(a)){return}var d,g,b=e.nRows,f=e.nCols;for(d=0;d<b;d++){if(d>=this.nRows){this[d]={}}for(g=0;g<f;g++){this[d][g]=e[d][g]+a[d][g]}for(g=f;g<this.nCols;g++){delete this[d][g]}}for(d=b;d<this.nRows;d++){delete this[d]}this.nRows=b;this.nCols=f};Matrix.prototype.sub=function(b){if(!this.isSameSizeAs(b)){return null}var e,g,d=this.nRows,f=this.nCols,a=new Matrix();for(e=0;e<d;e++){a[e]={};for(g=0;g<f;g++){a[e][g]=this[e][g]-b[e][g]}}a.nRows=d;a.nCols=f;return a};Matrix.prototype.isub=function(a){if(!this.isSameSizeAs(a)){return}for(var b=0;b<this.nRows;b++){for(var d=0;d<this.nCols;d++){this[b][d]-=a[b][d]}}};Matrix.prototype.beDifferenceOf=function(e,a){if(!e.isSameSizeAs(a)){return}var d,g,b=e.nRows,f=e.nCols;for(d=0;d<b;d++){if(d>=this.nRows){this[d]={}}for(g=0;g<f;g++){this[d][g]=e[d][g]-a[d][g]}for(g=f;g<this.nCols;g++){delete this[d][g]}}for(d=b;d<this.nRows;d++){delete this[d]}this.nRows=b;this.nCols=f};Matrix.prototype.negated=function(){return this.mulf(-1)};Matrix.prototype.neg=Matrix.prototype.negated;Matrix.prototype.negate=function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<this.nCols;b++){this[a][b]*=-1}}};Matrix.prototype.ineg=Matrix.prototype.negate;Matrix.prototype.beNegativeOf=function(a){var d,f,b=a.nRows,e=a.nCols;for(d=0;d<b;d++){if(d>=this.nRows){this[d]={}}for(f=0;f<e;f++){this[d][f]=-a[d][f]}for(f=e;f<this.nCols;f++){delete this[d][f]}}for(d=b;d<this.nRows;d++){delete this[d]}this.nRows=b;this.nCols=e};Matrix.prototype.getRow=function(b){var a=new Vector();for(var d=0;d<this.nCols;d++){a[d]=this[b][d]}a.nElements=this.nCols;return a};Matrix.prototype.getCol=function(d){var a=new Vector();for(var b=0;b<this.nRows;b++){a[b]=this[b][d]}a.nElements=this.nRows;return a};Matrix.prototype.setRow=function(b,a){if(b<0||b>=this.nRows){return}var e=a.nElements;if(this.nCols!=e){return}for(var d=0;d<this.nCols;d++){this[b][d]=a[d]}};Matrix.prototype.setCol=function(e,a){if(e<0||e>=this.nCols){return}var d=a.nElements;if(this.nRows!=d){return}for(var b=0;b<this.nRows;b++){this[b][e]=a[b]}};Matrix.prototype.incrRow=function(b,a){if(b<0||b>=this.nRows){return}var e=a.nElements;if(this.nCols!=e){return}for(var d=0;d<this.nCols;d++){this[b][d]+=a[d]}};Matrix.prototype.incrCol=function(e,a){if(e<0||e>=this.nCols){return}var d=a.nElements;if(this.nRows!=d){return}for(var b=0;b<this.nRows;b++){this[b][e]+=a[b]}};Matrix.prototype.decrRow=function(b,a){if(b<0||b>=this.nRows){return}var e=a.nElements;if(this.nCols!=e){return}for(var d=0;d<this.nCols;d++){this[b][d]-=a[d]}};Matrix.prototype.decrCol=function(e,a){if(e<0||e>=this.nCols){return}var d=a.nElements;if(this.nRows!=d){return}for(var b=0;b<this.nRows;b++){this[b][e]-=a[b]}};Matrix.prototype.swapRows=function(c,a){if(c==a){return}if(c<0||c>=this.nRows||a<0||a>=this.nRows){return}var b=this[c];this[c]=this[a];this[a]=b};Matrix.prototype.swapCols=function(c,b){if(c==b){return}if(c<0||c>=this.nCols||b<0||b>=this.nCols){return}var a;for(var d=0;d<this.nRows;d++){a=this[d][c];this[d][c]=this[d][b];this[d][b]=a}};Matrix.prototype.permuteRows=function(a,d){var e,c,a;if(a.nElements==undefined){e=a.length;a=a.slice()}else{e=a.nElements;a=a.toArray()}if(e!=this.nRows){return}for(var c=0;c<e;c++){if(c<0||c>=this.nRows){return}}var d=d||false;var b;if(d){for(c=0;c<e;c++){b=a[c];while(b!=c){this.swapRows(c,b);a[c]=a[b];a[b]=b;b=a[c]}}}else{for(c=e-1;c>0;c--){b=a[c];this.swapRows(c,b);a[a.indexOf(c)]=b}}return};Matrix.prototype.rowPermutation=function(a,e){var d,g,f=a.nElements==undefined?a.length:a.nElements;if(f!=this.nRows){return null}for(var d=0;d<f;d++){if(d<0||d>=this.nRows){return}}var b=new Matrix();if(e){for(d=0;d<this.nRows;d++){b[d]={}}for(d=0;d<this.nRows;d++){for(g=0;g<this.nCols;g++){b[a[d]][g]=this[d][g]}}}else{for(d=0;d<this.nRows;d++){b[d]={};for(g=0;g<this.nCols;g++){b[d][g]=this[a[d]][g]}}}b.nRows=this.nRows;b.nCols=this.nCols;return b};Matrix.prototype.mulf=function(e){var a=new Matrix(),d,h,b=this.nRows,g=this.nCols;for(d=0;d<b;d++){a[d]={};for(h=0;h<g;h++){a[d][h]=e*this[d][h]}}a.nRows=b;a.nCols=g;return a};Matrix.prototype.imulf=function(b){for(var a=0;a<this.nRows;a++){for(var d=0;d<this.nCols;d++){this[a][d]*=b}}};Matrix.prototype.mulv=function(d){if(!this.canMultiplyVec(d)){return null}var b=new Vector();var a;for(var e=0;e<this.nRows;e++){a=0;for(var f=0;f<this.nCols;f++){a+=this[e][f]*d[f]}b[e]=a}b.nElements=this.nRows;return b};Matrix.prototype.mulm=function(e){if(!this.canMultiplyMat(e)){return null}var d=new Matrix(),f,g,b;var a;for(f=0;f<this.nRows;f++){d[f]={};for(g=0;g<e.nCols;g++){a=0;for(b=0;b<this.nCols;b++){a+=this[f][b]*e[b][g]}d[f][g]=a}}d.nRows=this.nRows;d.nCols=e.nCols;return d};Matrix.prototype.mul=function(a){if(a instanceof Vector){return this.mulv(a)}if(a instanceof Matrix){return this.mulm(a)}if((typeof a).toLowerCase()=="number"){return this.mulf(a)}return null};Matrix.prototype.x=Matrix.prototype.mul;Matrix.prototype.beDyadicProductOf=function(e,a){var d,g,b=e.nElements,f=a.nElements;for(d=0;d<b;d++){if(d>=this.nRows){this[d]={}}for(g=0;g<f;g++){this[d][g]=e[d]*a[g]}for(g=f;g<this.nCols;g++){delete this[d][g]}}for(d=b;d<this.nRows;d++){delete this[d]}this.nRows=b;this.nCols=f};Matrix.prototype.beProductOf=function(g,d){if(!g.canMultiplyMat(d)){return}var f,h,b,a,e=g.nRows;nc=d.nCols;for(f=0;f<e;f++){if(f>=this.nRows){this[f]={}}for(h=0;h<nc;h++){a=0;for(b=0;b<g.nCols;b++){a+=g[f][b]*d[b][h]}this[f][h]=a}for(h=nc;h<this.nCols;h++){delete this[f][h]}}for(f=e;f<this.nRows;f++){delete this[f]}this.nRows=e;this.nCols=nc};Matrix.prototype.beTProductOf=function(g,d){var f,h,b,a,e=g.nCols;nc=d.nCols;if(g.nRows!=d.nRows){return}for(f=0;f<e;f++){if(f>=this.nRows){this[f]={}}for(h=0;h<nc;h++){a=0;for(b=0;b<g.nRows;b++){a+=g[b][f]*d[b][h]}this[f][h]=a}for(h=nc;h<this.nCols;h++){delete this[f][h]}}for(f=e;f<this.nRows;f++){delete this[f]}this.nRows=e;this.nCols=nc};Matrix.prototype.beProductTOf=function(g,d){var f,h,b,a,e=g.nRows;nc=d.nRows;if(g.nCols!=d.nCols){return}for(f=0;f<e;f++){if(f>=this.nRows){this[f]={}}for(h=0;h<nc;h++){a=0;for(b=0;b<g.nCols;b++){a+=g[f][b]*d[h][b]}this[f][h]=a}for(h=nc;h<this.nCols;h++){delete this[f][h]}}for(f=e;f<this.nRows;f++){delete this[f]}this.nRows=e;this.nCols=nc};Matrix.prototype.beTProductTOf=function(g,d){var f,h,b,a,e=g.nRows;nc=d.nCols;if(g.nCols!=d.nCols){return}for(f=0;f<e;f++){if(f>=this.nRows){this[f]={}}for(h=0;h<nc;h++){a=0;for(b=0;b<g.nRows;b++){a+=g[b][f]*d[h][b]}this[f][h]=a}for(h=nc;h<this.nCols;h++){delete this[f][h]}}for(f=e;f<this.nRows;f++){delete this[f]}this.nRows=e;this.nCols=nc};Matrix.prototype.transposed=function(){var a=new Matrix(this.nCols,this.nRows);for(var b=0;b<this.nCols;b++){a[b]={};for(var d=0;d<this.nRows;d++){a[b][d]=this[d][b]}}return a};Matrix.prototype.T=Matrix.prototype.transposed;Matrix.prototype.transpose=function(){var a,d,g,b=this.nRows,f=this.nCols,e=Math.min(b,f);for(d=0;d<e;d++){for(g=d+1;g<e;g++){a=this[d][g];this[d][g]=this[g][d];this[g][d]=a}}if(b>f){for(d=f;d<b;d++){for(g=0;g<f;g++){this[g][d]=this[d][g]}delete this[d]}}else{if(b<f){for(g=b;g<f;g++){this[g]={};for(d=0;d<b;d++){this[g][d]=this[d][g];delete this[d][g]}}}}this.nRows=f;this.nCols=b};Matrix.prototype.beTranspositionOf=function(a){var d,f,b=a.nCols,e=a.nRows;for(d=0;d<b;d++){if(d>=this.nRows){this[d]={}}for(f=0;f<e;f++){this[d][f]=a[f][d]}for(f=e;f<this.nCols;f++){delete this[d][f]}}for(d=b;d<this.nRows;d++){delete this[d]}this.nRows=b;this.nCols=e};Matrix.prototype.symmetrize=function(){if(!this.isSquare()){return}var b,e,a,d=this.nRows;for(b=0;b<d-1;b++){for(e=b+1;e<d;e++){a=0.5*(this[b][e]+this[e][b]);this[b][e]=a;this[e][b]=a}}};Matrix.prototype.symmetrized=function(){if(!this.isSquare()){return null}ret=new Matrix();var b,e,a,d=this.nRows;for(b=0;b<d;b++){ret[b]={}}for(b=0;b<d;b++){ret[b][b]=this[b][b]}for(b=0;b<d-1;b++){for(e=b+1;e<d;e++){a=0.5*(this[b][e]+this[e][b]);ret[b][e]=a;ret[e][b]=a}}ret.nRows=d;ret.nCols=d;return ret};Matrix.prototype.giveSymmetricPart=Matrix.prototype.symmetrized;Matrix.prototype.beSymmetricPartOf=function(b){if(!b.isSquare()){return}var d,f,a,e=b.nRows;for(d=0;d<e;d++){if(d>=this.nRows){this[d]={}}this[d][d]=b[d][d]}for(d=0;d<e-1;d++){for(f=d+1;f<e;f++){a=0.5*(b[d][f]+b[f][d]);this[d][f]=a;this[f][d]=a}for(f=e;f<this.nCols;f++){delete this[d][f]}}for(d=e;d<this.nRows;d++){delete this[d]}this.nRows=e;this.nCols=e};Matrix.prototype.antiSymmetrize=function(){if(!this.isSquare()){return}var b,e,a,d=this.nRows;for(b=0;b<d;b++){this[b][b]=0}for(b=0;b<d;b++){for(e=b+1;e<d;e++){a=0.5*(this[b][e]+this[e][b]);this[b][e]-=a;this[e][b]-=a}}};Matrix.prototype.antiSymmetrized=function(){if(!this.isSquare()){return null}ret=new Matrix();var b,e,a,d=this.nRows;for(b=0;b<d;b++){ret[b]={}}for(b=0;b<d;b++){ret[b][b]=0}for(b=0;b<d-1;b++){for(e=b+1;e<d;e++){a=0.5*(this[b][e]+this[e][b]);ret[b][e]=this[b][e]-a;ret[e][b]=this[e][b]-a}}ret.nRows=d;ret.nCols=d;return ret};Matrix.prototype.giveAntiSymmetricPart=Matrix.prototype.antiSymmetrized;Matrix.prototype.beAntiSymmetricPartOf=function(b){if(!b.isSquare()){return}var d,f,a,e=b.nRows;for(d=0;d<e;d++){if(d>=this.nRows){this[d]={}}this[d][d]=0}for(d=0;d<e;d++){for(f=d+1;f<e;f++){a=0.5*(b[d][f]+b[f][d]);this[d][f]=b[d][f]-a;this[f][d]=b[f][d]-a}for(f=e;f<this.nCols;f++){delete this[d][f]}}for(d=e;d<this.nRows;d++){delete this[d]}this.nRows=e;this.nCols=e};Matrix.prototype.getSubMatrix=function(j,h){var i=j.nElements==undefined?j.length:j.nElements;var e=h.nElements==undefined?h.length:h.nElements;if(i>this.nRows||e>this.nCols){return null}var a,g,d,b;var f=new Matrix();for(a=0;a<i;a++){f[a]={};for(g=0;g<e;g++){d=j[a];b=h[g];if(d<0||d>=this.nRows){return null}if(b<0||b>=this.nCols){return null}f[a][g]=this[d][b]}}f.nRows=i;f.nCols=e;return f};Matrix.prototype.getsm=Matrix.prototype.getSubMatrix;Matrix.prototype.beSubMatrixOf=function(a,e,f){var d=e.nElements==undefined?e.length:e.nElements;var h=f.nElements==undefined?f.length:f.nElements;if(d>a.nRows||h>a.nCols){return null}var b,g;for(b=0;b<n;b++){if(e[b]<0||e[b]>=a.nRows){return}}for(g=0;g<n;g++){if(f[g]<0||f[g]>=a.nCols){return}}for(b=0;b<d;b++){this[b]={};for(g=0;g<h;g++){this[b][g]=a[e[b]][f[g]]}for(g=h;g<this.nCols;g++){delete this[b][g]}}for(b=d;b<this.nRows;b++){delete this[b]}this.nRows=d;this.nCols=h};Matrix.prototype.setSubMatrix=function(j,g,i){var h=j.nElements==undefined?j.length:j.nElements;var d=g.nElements==undefined?g.length:g.nElements;var e=i.nRows,b=i.nCols;if(e!=h||b!=d){return}if(h>this.nRows||d>this.nCols){return}var a,f;for(a=0;a<n;a++){if(j[a]<0||j[a]>=this.nRows){return}}for(f=0;f<n;f++){if(g[f]<0||g[f]>=this.nCols){return}}for(a=0;a<h;a++){for(f=0;f<d;f++){this[j[a]][g[f]]=i[a][f]}}};Matrix.prototype.setsm=Matrix.prototype.setSubMatrix;Matrix.prototype.incrSubMatrix=function(j,g,i){var h=j.nElements==undefined?j.length:j.nElements;var d=g.nElements==undefined?g.length:g.nElements;var e=i.nRows,b=i.nCols;if(e!=h||b!=d){return}if(h>this.nRows||d>this.nCols){return}var a,f;for(a=0;a<n;a++){if(j[a]<0||j[a]>=this.nRows){return}}for(f=0;f<n;f++){if(g[f]<0||g[f]>=this.nCols){return}}for(a=0;a<h;a++){for(f=0;f<d;f++){this[j[a]][g[f]]+=i[a][f]}}};Matrix.prototype.incrsm=Matrix.prototype.incrSubMatrix;Matrix.prototype.decrSubMatrix=function(j,g,i){var h=j.nElements==undefined?j.length:j.nElements;var d=g.nElements==undefined?g.length:g.nElements;var e=i.nRows,b=i.nCols;if(e!=h||b!=d){return}if(h>this.nRows||d>this.nCols){return}var a,f;for(a=0;a<n;a++){if(j[a]<0||j[a]>=this.nRows){return}}for(f=0;f<n;f++){if(g[f]<0||g[f]>=this.nCols){return}}for(a=0;a<h;a++){for(f=0;f<d;f++){this[j[a]][g[f]]-=i[a][f]}}};Matrix.prototype.decrsm=Matrix.prototype.decrSubMatrix;Matrix.prototype.assemble=function(i,j,g){var h=j.nElements==undefined?j.length:j.nElements;var d=g.nElements==undefined?g.length:g.nElements;var e=this.nRows,b=this.nCols;if(e!=h||b!=d){return}if(h>i.nRows||d>i.nCols){return}var a,f;for(a=0;a<h;a++){if(j[a]<0||j[a]>=i.nRows){return}}for(f=0;f<d;f++){if(g[f]<0||g[f]>=i.nCols){return}}for(a=0;a<h;a++){for(f=0;f<d;f++){i[j[a]][g[f]]+=this[a][f]}}};Matrix.prototype.copied=function(){var a=new Matrix();for(var b=0;b<this.nRows;b++){a[b]={};for(var d=0;d<this.nCols;d++){a[b][d]=this[b][d]}}a.nRows=this.nRows;a.nCols=this.nCols;return a};Matrix.prototype.copy=Matrix.prototype.copied;Matrix.prototype.beCopyOf=function(a){var d,f,b=a.nRows,e=a.nCols;for(d=0;d<b;d++){if(d>=this.nRows){this[d]={}}for(f=0;f<e;f++){this[d][f]=a[d][f]}for(f=e;f<this.nCols;f++){delete this[d][f]}}for(d=b;d<this.nRows;d++){delete this[d]}this.nRows=b;this.nCols=e};Matrix.prototype.diagonalToVector=function(){if(!this.isSquare()){return null}var a=new Vector();for(var b=0;b<this.nRows;b++){a[b]=this[b][b]}a.nElements=this.nRows;return a};Matrix.prototype.diag=Matrix.prototype.diagonalToVector;Matrix.prototype.toString=function(){var d=this.nRows;var g=this.nCols;var b,f,e;var a="Matrix([[ ";if(d==0){return a+"]])"}if(g==0){for(b=0;b<d-1;b++){a+=" [], "}return a+"])"}for(b=0;b<d-1;b++){for(f=0;f<g-1;f++){e=this[b][f];a+=e.toExponential(3)+", "}e=this[b][g-1];a+=e.toExponential(3)+" ], [ "}for(f=0;f<g-1;f++){e=this[d-1][f];a+=e.toExponential(3)+", "}e=this[d-1][g-1];a+=e.toExponential(3)+" ]])";return a};Matrix.prototype.resize=function(a,b){if(this.nRows<a){for(var d=this.nRows;d<a;d++){this[d]={};for(var e=0;e<this.nCols;e++){this[d][e]=0}}this.nRows=a}if(this.nRows>a){for(var d=a;d<this.nRows;d++){delete this[d]}this.nRows=a}if(this.nCols<b){for(var d=0;d<this.nRows;d++){for(var e=this.nCols;e<b;e++){this[d][e]=0}}this.nCols=b}if(this.nCols>b){for(var d=0;d<this.nRows;d++){for(var e=b;e<this.nCols;e++){delete this[d][e]}}this.nCols=b}};Matrix.prototype.resized=function(b,d){var e,f,a=new Matrix();for(var e=0;e<b;e++){a[e]={}}if(b<=this.nRows){if(d<=this.nCols){for(e=0;e<b;e++){for(f=0;f<d;f++){a[e][f]=this[e][f]}}}else{for(e=0;e<b;e++){for(f=0;f<this.nCols;f++){a[e][f]=this[e][f]}for(f=this.nCols;f<d;f++){a[e][f]=0}}}}else{if(d<=this.nCols){for(e=0;e<this.nRows;e++){for(f=0;f<d;f++){a[e][f]=this[e][f]}}for(e=this.nRows;e<b;e++){for(f=0;f<d;f++){a[e][f]=0}}}else{for(e=0;e<this.nRows;e++){for(f=0;f<this.nRows;f++){a[e][f]=this[e][f]}for(f=this.nCols;f<d;f++){a[e][f]=0}}for(e=this.nRows;e<b;e++){for(f=0;f<d;f++){a[e][f]=0}}}}a.nRows=b;a.nCols=d;return a};Matrix.prototype.appendRows=function(d){if(d instanceof Vector){if(d.nElements!=this.nCols){return}this[this.nRows]={};for(var e=0;e<this.nCols;e++){this[this.nRows][e]=d[e]}this.nRows++;return}if(d instanceof Matrix){if(d.nCols!=this.nCols){return}for(var b=0;b<d.nRows;b++){this[this.nRows]={};for(var e=0;e<this.nCols;e++){this[this.nRows][e]=d[b][e]}this.nRows++}return}if(d instanceof Array){for(var a=0;a<d.length;a++){this.appendRows(d[a])}}};Matrix.prototype.appendCols=function(d){if(d instanceof Vector){if(d.nElements!=this.nRows){return}for(var b=0;b<this.nRows;b++){this[b][this.nCols]=d[b]}this.nCols++;return}if(d instanceof Matrix){if(d.nRows!=this.nRows){return}for(var b=0;b<this.nRows;b++){for(var e=0;e<d.nCols;e++){this[b][this.nCols+e]=d[b][e]}}this.nCols+=d.nCols;return}if(d instanceof Array){for(var a=0;a<d.length;a++){this.appendCols(d[a])}}};Matrix.prototype.isEqualTo=function(a){if(!this.isSameSizeAs(a)){return false}for(var b=0;b<this.nRows;b++){for(var d=0;d<this.nCols;d++){if(Math.abs(this[b][d]-a[b][d])>JSM_TOL){return false}}}return true};Matrix.prototype.isSameSizeAs=function(a){return(this.nRows==a.nRows&&this.nCols==a.nCols)};Matrix.prototype.canMultiplyMat=function(a){return(this.nCols==a.nRows)};Matrix.prototype.canMultiplyVec=function(a){return(this.nCols==a.nElements)};Matrix.prototype.isSquare=function(){return(this.nRows==this.nCols)};Matrix.prototype.isSymmetric=function(){if(!this.isSquare()){return false}for(var a=0;a<this.nRows;a++){for(var b=a+1;b<this.nCols;b++){if(Math.abs(this[a][b]-this[b][a])>JSM_TOL){return false}}}return true};Matrix.prototype.isTranspositionOf=function(a){if(this.nRows!=a.nCols||this.nCols!=a.nRows){return false}var b,d;for(b=0;b<this.nRows;b++){for(d=0;d<this.nCols;d++){if(Math.abs(this[b][d]-a[d][b])>JSM_TOL){return false}}}return true};Matrix.prototype.isLowerTriangular=function(){for(var a=0;a<this.nRows;a++){for(var b=a+1;b<this.nCols;b++){if(Math.abs(this[a][b])>JSM_TOL){return false}}}return true};Matrix.prototype.isUpperTriangular=function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<a;b++){if(Math.abs(this[a][b])>JSM_TOL){return false}}}return true};Matrix.prototype.isSingular=function(){var a=this.determinant();return isNaN(a)?true:(Math.abs(a)<JSM_TOL)};Matrix.prototype.isIdentity=function(){if(!this.isSquare()){return false}var a,b;for(var a=0;a<this.nRows;a++){if(Math.abs(this[a][a]-1)>JSM_TOL){return false}}for(var a=1;a<this.nRows;a++){for(var b=a+1;b<this.nCols;b++){if(Math.abs(this[a][b])>JSM_TOL){return false}if(Math.abs(this[b][a])>JSM_TOL){return false}}}return true};Matrix.prototype.isUnitMatrix=Matrix.prototype.isIdentity;Matrix.prototype.isZero=function(){for(var b=0;b<this.nRows;b++){for(var a=0;a<this.nCols;a++){if(Math.abs(this[b][a])>JSM_TOL){return false}}}return true};Matrix.prototype.containsOnlyZeros=Matrix.prototype.isZero;Matrix.prototype.isOne=function(){for(var a=0;a<this.nRows;a++){for(var b=0;b<this.nCols;b++){if(Math.abs(this[a][b]-1)>2*JSM_TOL){return false}}}return true};Matrix.prototype.containsOnlyOnes=Matrix.prototype.isOne;Matrix.prototype.isOrthogonal=function(){var a=new Matrix();a.beProductTOf(this,this);return a.isIdentity()};Matrix.prototype.isPositiveDefinite=function(){return this.choleskyDecomposition()!=null};Matrix.prototype.isInvolutary=function(){var a=new Matrix();a.beProductOf(this,this);return a.isIdentity()};Matrix.prototype.implicitPartialPivotPermutation=function(h){var h=h==undefined?true:h;var b=this.nRows;var g=h?this.copy():this;var l=[];var a=range(b);var c,f,e,d;for(f=0;f<b;f++){c=0;for(e=0;e<b;e++){if((temp=Math.abs(g[f][e]))>c){c=temp}}if(c==0){return null}l[f]=1/c}for(d=0;d<b;d++){c=0;for(f=d;f<b;f++){temp=l[f]*Math.abs(g[f][d]);if(temp>c){c=temp;imax=f}}if(d!=imax){g.swapRows(d,imax);l[imax]=l[d];temp=a[d];a[d]=imax;a[imax]=temp}}return[g,a]};Matrix.prototype.forwardSubstitution=function(f,d){if(!this.isSquare()||!this.canMultiplyVec(f)){return null}var d=d==undefined?true:d;var a;var g=this.nRows;var c=d?f.copy():f;var e,b;for(e=0;e<g;e++){a=c[e];for(b=0;b<e;b++){a-=this[e][b]*c[b]}c[e]=a/this[e][e]}return c};Matrix.prototype.backwardSubstitution=function(f,d){if(!this.isSquare()||!this.canMultiplyVec(f)){return null}var d=d==undefined?true:d;var a;var g=this.nRows;var c=d?f.copy():f;var e,b;for(e=g-1;e>=0;e--){a=c[e];for(b=e+1;b<g;b++){a-=this[e][b]*c[b]}c[e]=a/this[e][e]}return c};Matrix.prototype.gaussianElimination=function(h,c,l){if(!this.canMultiplyVec(h)||!this.isSquare()){return null}var c=c||"default";var l=l==undefined?true:l;var d=this.nRows;var g,f,e;if(c=="nopivot"||c=="default"){var o=l?this.copy():this;var m=l?h.copy():h;for(e=0;e<d-1;e++){akk=o[e][e];for(g=e+1;g<d;g++){for(f=e+1;f<d;f++){o[g][f]-=o[e][f]*o[g][e]/akk}m[g]-=m[e]*o[g][e]/akk}}return o.backwardSubstitution(m,false)}if(c=="partpivot"){var o=this.implicitPartialPivotPermutation(l);var m=l?h.copy():h;m.permuteElements(o[1]);return o[0].gaussianElimination(m,"nopivot",false)}return this.gaussianElimination(h,"default",l)};Matrix.prototype.gaussJordanElimination=function(m,c,o){if(!this.isSquare){return null}var d=(m instanceof Vector)?1:((m instanceof Array)?2:((m instanceof Matrix)?3:4));if(!(d==1||d==2||d==3)){return null}var c=c||"default";var o=o==undefined?true:o;var l,h,g,f;var e=this.nRows;var t=d==2?m.length:(d==3?m.nCols:1);if(c=="default"||c=="nopivot"){var q=o?this.copy():this;var p;if(d==1||d==3){p=o?m.copy():m}else{p=[];for(l=0;l<t;l++){p[l]=o?m[l].copy():m[l]}}for(g=0;g<e;g++){f=q[g][g];for(l=g+1;l<e;l++){for(h=g+1;h<e;h++){q[l][h]-=q[g][h]*q[l][g]/f}switch(d){case 1:p[l]-=p[g]*q[l][g]/f;break;case 2:for(h=0;h<t;h++){p[h][l]-=p[h][g]*q[l][g]/f}break;case 3:for(h=0;h<t;h++){p[l][h]-=p[g][h]*q[l][g]/f}break}}}for(g=e-1;g>=0;g--){f=q[g][g];for(l=g-1;l>=0;l--){for(h=e-1;h>g;h--){q[l][h]-=q[g][h]*q[l][g]/f}switch(d){case 1:p[l]-=p[g]*q[l][g]/f;break;case 2:for(h=0;h<t;h++){p[h][l]-=p[h][g]*q[l][g]/f}break;case 3:for(h=0;h<t;h++){p[l][h]-=p[g][h]*q[l][g]/f}break}}}for(g=0;g<e;g++){f=q[g][g];switch(d){case 1:p[g]/=f;break;case 2:for(h=0;h<t;h++){p[h][g]/=f}break;case 3:for(h=0;h<t;h++){p[g][h]/=f}break}}return p}if(c=="partpivot"){var q=this.implicitPartialPivotPermutation(o);var r;switch(d){case 1:r=o?m.copy():m;r.permuteElements(q[1]);break;case 2:r=[];for(l=0;l<t;l++){r[l]=o?m[l].copy():m[l];r[l].permuteElements(q[1])}break;case 3:r=o?m.copy():m;r.permuteRows(q[1]);break}return q[0].gaussJordanElimination(r,"nopivot",false)}return this.gaussJordanElimination(m,"default",o)};Matrix.prototype.choleskyDecomposition=function(g,b){var b=b==undefined?true:check;if(!this.isSquare()){return null}if(b){if(!this.isSymmetric()){return null}}var g=g==undefined?true:g;var c=this.nRows;var h=g?this.copy():this;var m,l,f,e,d;for(f=0;f<c;f++){m=h[f][f];for(d=0;d<f;d++){m-=h[f][d]*h[f][d]}if(m<=0){return null}m=Math.sqrt(m);h[f][f]=m;for(e=f+1;e<c;e++){l=h[e][f];for(d=0;d<f;d++){l-=h[f][d]*h[e][d]}h[e][f]=l/m}for(d=f+1;d<c;d++){h[f][d]=0}}return h};Matrix.prototype.chol=Matrix.prototype.choleskyDecomposition;Matrix.prototype.lltDecomposition=Matrix.prototype.choleskyDecomposition;Matrix.prototype.luDecomposition=function(b){if(!this.isSquare()){return null}var b=b||"default";var c=this.nRows;var d=Matrix.Zeros(c,c);var q=Matrix.Zeros(c,c);var h,g,f,e;var p;if(b=="default"||b=="nopivot"){for(f=0;f<c;f++){d[f][f]=1;for(g=f;g<c;g++){p=this[f][g];for(h=0;h<f;h++){p-=d[f][h]*q[h][g]}q[f][g]=p}for(g=f+1;g<c;g++){p=this[g][f];for(h=0;h<f;h++){p-=d[g][h]*q[h][f]}d[g][f]=p/q[f][f]}}return[d,q]}if(b=="partpivot"){var o=this.implicitPartialPivotPermutation();var m=o[0].luDecomposition("nopivot");m[2]=o[1];return m}return this.luDecomposition("default")};Matrix.prototype.lduDecomposition=function(b){if(!this.isSquare()){return null}var b=b||"default";if(b=="default"||b=="nopivot"){var c=this.nRows;var e=Matrix.Zeros(c,c);var o=Vector.Zeros(c);var q=Matrix.Zeros(c,c);var r;for(var h=0;h<c;h++){e[h][h]=1;q[h][h]=1;for(var g=0;g<h;g++){r=this[h][g];for(var f=0;f<g;f++){r-=e[h][f]*o[f]*q[f][g]}e[h][g]=r/o[g]}r=this[h][h];for(var f=0;f<h;f++){r-=e[h][f]*o[f]*q[f][h]}o[h]=r;for(var g=h+1;g<c;g++){r=this[h][g];for(var f=0;f<h;f++){r-=e[h][f]*o[f]*q[f][g]}q[h][g]=r/o[h]}}return[e,o,q]}if(b="partpivot"){var p=this.implicitPartialPivotPermutation();var m=p.lduDecomposition("nopivot");m[3]=p[1];return m}return this.lduDecomposition("default")};Matrix.prototype.qrDecomposition=function(b,o){if(!this.isSquare()){return null}var o=o==undefined?true:o;var b=b||"default";var g=this.nRows;if(b=="default"||b=="grammschmidt"||b=="gramm-schmidt"||b=="gs"){proj=function(a,e){return a.mulf(a.dot(e)/(a.dot(a)))};var c=o?this.copy():this;var f=new Matrix(g,g);var v,l=[];var i,h;for(h=0;h<g;h++){v=c.getCol(h);l[h]=v.copy();for(i=0;i<h;i++){l[h].isub(proj(l[i],v))}l[h].normalize();for(i=0;i<=h;i++){c[i][h]=l[i].dot(v)}for(i=h+1;i<g;i++){c[i][h]=0}f.setCol(h,l[h])}return[f,c]}if(b=="householder"){var c=o?this.copy():this;var l=Vector.Zeros(g);l[0]=1;var v,t,p,d,f=Matrix.Identity(g),m;for(var h=0;h<g-1;h++){l.resize(g-h);p=range(h,g);v=c.getSubMatrix(p,p);t=v.getCol(0);d=Matrix.Identity(g);m=t[h]>0?-1:1;d.setSubMatrix(p,p,Matrix.Householder(t.add(l.mulf(m*t.norm()))));c=d.mulm(c);f=f.mulm(d.transposed())}return[f,c]}return this.qrDecomposition("default",o)};Matrix.prototype.linSolve=function(k,b,o,f){var o=o==undefined?true:o;var b=b||"default";b=b.toLowerCase();if(b=="default"||b=="gauss"||b=="gaussian"){return this.gaussianElimination(k,"partpivot",o)}if(b=="gaussjordan"||b=="gauss-jordan"||b=="gj"){return this.gaussJordanElimination(k,"partpivot",o)}if(b=="lu"){var e=f||this.luDecomposition();var c=e[0];var t=e[1];var q;if(k instanceof Vector){q=c.forwardSubstitution(k,o);return t.backwardSubstitution(q,false)}if(k instanceof Matrix){var j=o?Matrix.Zeros(this.nRows,k.nCols):k;for(var g=0;g<j.nCols;g++){q=c.forwardSubstitution(k.getCol(g),false);j.setCol(g,t.backwardSubstitution(q,false))}return j}if(k instanceof Array){return null}}if(b=="ldu"){var h=f||this.lduDecomposition("nopivot",true);var c=h[0];var m=(h[1] instanceof Matrix)?h[1].diag():h[1];var t=h[2];var q=c.forwardSubstitution(k,o);for(var a=0;a<this.nRows;a++){q[a]/=m[a]}return t.backwardSubstitution(q,false)}if(b=="cholesky"||b=="chol"){var c=f||this.choleskyDecomposition();if(c==null){return null}var q=c.forwardSubstitution(k,o);return c.transposed().backwardSubstitution(q,false)}if(b=="qr"){var p=f||this.qrDecomposition("grammschmidt",o);return p[1].backwardSubstitution(p[0].transposed().mulv(k),false)}return this.linSolve(k,"default",o,f)};Matrix.prototype.schurForm=function(j,d){if(!this.isSquare()){return null}var e=this.nRows;var j=j==undefined?true:j;var d=d||1000;var m,p=j?this.copy():this;var f,l=Vector.Zeros(e),h=Vector.Zeros(e),c,g,b,a,k=0,o=Matrix.Identity(e);for(g=0;g<e;g++){l[g]=0}do{m=p.qrDecomposition();b=m[0];a=m[1];p=a.mulm(b);f=l.copy();l=p.diagonalToVector();for(g=0;g<e;g++){h[g]=Math.abs((l[g]-f[g])/l[g])}c=0;for(var g=0;g<e;g++){if(h[g]>c){c=h[g]}}k++;if(k>d){if(c>JSM_TOL){return null}break}}while(c>JSM_TOL2);return p};Matrix.prototype.schurDecomposition=function(j,d){if(!this.isSquare()){return null}var e=this.nRows;var j=j==undefined?true:j;var d=d||1000;var m,p=j?this.copy():this;var f,l=Vector.Zeros(e),h=Vector.Zeros(e),c,g,b,a,k=0,o=Matrix.Identity(e);for(g=0;g<e;g++){l[g]=0}do{m=p.qrDecomposition();b=m[0];o=o.mulm(b);a=m[1];p=a.mulm(b);f=l.copy();l=p.diagonalToVector();for(g=0;g<e;g++){h[g]=Math.abs((l[g]-f[g])/l[g])}c=0;for(var g=0;g<e;g++){if(h[g]>c){c=h[g]}}k++;if(k>d){if(c>JSM_TOL){return null}break}}while(c>JSM_TOL2);return[o,p]};Matrix.prototype.singularValueDecomposition=function(){if(!this.isSquare()){return null}var d=this.mulm(this.transposed());var h=d.nRows;var g=this.transposed().mulm(this);var i=g.nRows;var a=d.eigSymmetric({nEigModes:"all"});var f=g.eigSymmetric({nEigModes:"all"});var e=Matrix.Zeros(d.nRows,d.nCols);var c=Matrix.Zeros(g.nRows,g.nCols);for(var b=0;b<h;b++){e.setCol(b,a[1][b])}for(var b=0;b<i;b++){c.setCol(b,f[1][b])}s=[];for(var b=0;b<i;b++){s[b]=Math.sqrt(f[0][b])}return[e,Vector.create(s),c]};Matrix.prototype.svd=Matrix.prototype.singularValueDecomposition;Matrix.prototype.polarDecomposition=function(c){if(!this.isSquare){return null}var e=c?c:this.singularValueDecomposition();var b=e[0];var d=e[1];var a=e[2];return[b.mulm(a.transposed()),a.mulm(d.diag()).mulm(a.transposed())]};Matrix.prototype.eigSymmetric=function(I){if(!this.isSquare()){return null}var I=I||{};var H=I.mat||Matrix.Identity(this.nRows,this.nCols);if(!H.isSquare()||!this.isSameSizeAs(H)){return null}var m=I.nEigModes||this.nRows;if(m=="all"){m=this.nRows}else{if(m>this.nRows){m=this.nRows}}var d=I.method||"default";var e=I.highest||false;var b=I.maxiter||1000;if(d=="default"||d=="invit"){var o=e?H.inv().mulm(this):this.inv().mulm(H);var y=[];var F=[];var h=[];var a,g,z,D;var t=Vector.Zeros(this.nRows);for(var A=0;A<m;A++){t.one();D=0;z=0;do{t=o.mulv(t);for(var B=0;B<A;B++){t.isub(F[B].mulf(h[B].dot(t)))}t.imulf(1/t.energyNorm(H));a=z;z=t.squaredEnergyNorm(this)/t.squaredEnergyNorm(H);g=Math.abs((z-a)/z);D++;if(D>b){if(g>JSM_TOL){return null}break}}while(g>JSM_TOL2);y[A]=z;F[A]=t.copy();h[A]=t.mulm(H)}return[y,F]}if(d=="subspace"){var y=[];var F=[];var w=this.nRows;var c,E,p,v;var G,f,J,l,D;var t=Vector.Zeros(this.nRows);x=Matrix.Ones(w,m);for(var C=0;C<w;C++){x.set(C,C,0)}lu=e?H.luDecomposition():this.luDecomposition();rhosNew=[];for(var w=0;w<m;w++){rhosNew[w]=0}f=rhosNew.slice();D=0;do{x=e?H.linSolve(this.mulm(x),"lu",false,lu):this.linSolve(H.mulm(x),"lu",false,lu);c=x.transposed().mulm(this).mulm(x);E=x.transposed().mulm(H).mulm(x);p=c.eigSymmetric({mat:E,nEigModes:m,highest:e});v=Matrix.Zeros(m,m);for(var B=0;B<m;B++){v.setCol(B,p[1][B])}x=x.mulm(v);G=rhosNew.slice();rhosNew=p[0].slice();for(var w=0;w<m;w++){f[w]=Math.abs((rhosNew[w]-G[w])/rhosNew[w])}l=0;for(var w=0;w<m;w++){if(f[w]>l){l=f[w]}}D++;if(D>b){if(l>JSM_TOL){return null}break}}while(l>JSM_TOL2);for(var C=0;C<m;C++){y.push(p[0][C]);F.push(x.getCol(C))}return[y,F]}I.method="default";return this.eig(I)};Matrix.prototype.eigVals=function(a){var a=a||"default";a=a.toLowerCase();if(a=="default"||a=="schur"){return this.schurForm().diagonalToVector().toArray()}return this.eigVals("default")};Matrix.prototype.eigenDecomposition=function(b,w){if(!this.isSquare){return null}var b=b||"default";if(b=="default"){var k,h,f=this.nRows;var r=w?w:this.schurDecomposition();var c=r[0];var B=r[1];var g=new Matrix(f,f);for(k=0;k<f;k++){g[k][k]=B[k][k]}var d=Matrix.Zeros(f,f);var a=new Matrix(),A,m,z=new Vector(),t=new Vector(f);d.setCol(0,c.getCol(0));for(k=1;k<f;k++){ii=range(k);a.beSubMatrixOf(B,ii,ii);m=B[k][k];z.resize(k);for(h=0;h<k;h++){a[h][h]-=m;z[h]=B[h][k]}t.beSolutionOf(a,z);t.negate();t.appendElements(1);t.resize(f);d.setCol(k,c.mulv(t))}return[d,g]}if(b=="symm"||b=="symmeig"||b=="eigsymm"||b=="eigsymmetric"){var f=this.nRows;var o=this.eigSymmetric();var d=Matrix.Zeros(f,f);var g=Matrix.Zeros(f,f);for(var k=0;k<f;k++){d.setCol(k,o[1][k]);g[k][k]=o[0][k]}return[d,g]}return this.eigenDecomposition("default")};Matrix.prototype.spectralDecomposition=Matrix.prototype.eigenDecomposition;Matrix.prototype.inversed=function(a,h){if(!this.isSquare){return null}var a=a||"default";a=a.toLowerCase();if(a=="default"||a=="gaussjordan"){return this.gaussJordanElimination(Matrix.Identity(this.nRows,this.nRows))}if(a=="lu"){var g=h?h:this.luDecomposition();var c=this.nRows;var m=new Matrix(c,c);var d=Vector.Zeros(c);for(var j=0;j<c;j++){d.zero();d[j]=1;this.linSolve(d,"lu",false,g);m.setCol(j,d)}return m}if(a=="chol"||a=="cholesky"){var f=h?h:this.choleskyDecomposition();if(f==null){return null}var c=this.nRows;var m=new Matrix(c,c);var d=Vector.Zeros(c);for(var j=0;j<c;j++){d.zero();d[j]=1;this.linSolve(d,"cholesky",false,f);m.setCol(j,d)}return m}if(a=="eigen"||a=="eig"){var k=h?h:this.eigenDecomposition();var b=k[0];var f=k[1];for(var j=0;j<this.nRows;j++){f[j][j]=1/f[j][j]}return b.mulm(f).mulm(b.inversed())}if(a=="symmeig"||a=="eigsymm"||a=="eigsymmetric"){var k=h?h:this.eigenDecomposition("symm");var b=k[0];var f=k[1];for(var j=0;j<this.nRows;j++){f[j][j]=1/f[j][j]}return b.mulm(f).mulm(b.transposed())}if(a=="svd"){svd=h?h:this.singularValueDecomposition();var q=svd[0],t=svd[1],o=svd[2];var c=t.nElements;var r=new Matrix(c,c);for(var j=0;j<c;j++){if(t[j]>JSM_TOL){r[j][j]=1/t[j]}}return o.mulm(r).mulm(q.transposed())}return this.inversed("default")};Matrix.prototype.inv=Matrix.prototype.inversed;Matrix.prototype.beInverseOf=function(b,d,c){if(!b.isSquare()){return}var d=d||"default";d=d.toLowerCase();if(d=="default"||d=="gaussjordan"){var a=b.copy();this.beUnitMatrix(b.nRows);a.gaussJordanElimination(this,"nopivot",false);return}else{this.beCopyOf(b.inversed(d,c))}this.beInverseOf(b,"default",c)};Matrix.prototype.determinant=function(e,d){if(!this.isSquare()){return null}var e=e||"default";e=e.toLowerCase();var c=d||undefined;if(e=="default"||e=="lu"){u=d?d[1]:this.luDecomposition()[1];return u.diagProduct()}if(e=="schurform"||e=="schur"){var b=d?d:this.schurForm();return b.diagProduct()}if(e=="schurdecomposition"){var b=d?d:this.schurDecomposition()[1];return b.diagProduct()}if(e=="eigen"||e=="eigendecomposition"){var a=d?d[1]:this.eigenDecomposition()[1];return a.diagProduct()}return this.determinant("default",d)};Matrix.prototype.det=Matrix.prototype.determinant;Matrix.prototype.giveDeterminant=Matrix.prototype.determinant;Matrix.create=function(g){if(g==undefined){return new Matrix()}if(g.length==0){return new Matrix()}var b=g;var d=b.length,e=b[0].length,f,h;ret=new Matrix();for(var f=0;f<d;f++){ret[f]={};for(var h=0;h<e;h++){ret[f][h]=g[f][h]}}ret.nRows=d;ret.nCols=e;return ret};Matrix.Diagonal=function(d){var c=d.nElements==undefined?d.length:d.nElements;var a=new Matrix(c,c);for(var b=0;b<c;b++){a[b][b]=d[b]}return a};Matrix.Identity=function(c){var a=new Matrix(c,c);for(var b=0;b<c;b++){a[b][b]=1}return a};Matrix.I=Matrix.Identity;Matrix.UnitMatrix=Matrix.Identity;Matrix.Zeros=function(a,b){return new Matrix(a,b)};Matrix.Ones=function(b,d){var b=b||0;var d=d||0;var a=new Matrix();for(var e=0;e<b;e++){a[e]={};for(var f=0;f<d;f++){a[e][f]=1}}a.nRows=b;a.nCols=d;return a};Matrix.Householder=function(c,b){var a=c.nElements==undefined?c.length:c.nElements;return(b?b:Matrix.Identity(a)).sub(c.dyadic(c).mulf(2/c.dot(c)))};mat=Matrix.create;vec=Vector.create;zeros=function(a,b){if(b){return Matrix.Zeros(a,b)}if(a){return Vector.Zeros(a)}return null};ones=function(a,b){if(b){return Matrix.Ones(a,b)}if(a){return Vector.Ones(a)}return null};identity=Matrix.Identity;eye=Matrix.Identity;unitMatrix=Matrix.Identity;linSolve=function(b,f,c,e,d){return b.linSolve(f,c,e,d)};eigSolve=function(a){return a.mat1.eig({mat:a.mat2,nEigModes:a.nEigModes,method:a.method,highest:a.highest,maxiter:a.maxiter})};range=function(e,d,k){var j;var h;var g;if(d==null&&k==null){j=0;g=e;h=1}else{if(k==null){j=e;g=d;h=1}else{j=e;g=d;h=k}}var f=[];var i=j;while(i<g){f.push(i);i+=h}return f};Array.prototype.indexOf=function(b){for(var a=0;a<this.length;a++){if(this[a]===b){return a}}};